#!/usr/bin/perl

sub load_fnames {
	my ($path) = @_;

	opendir(DIR, $path);
	my (@all_fnames) = readdir(DIR);
	closedir(DIR);

	my %fnames;
	foreach (@all_fnames) {
		$fnames{$_} = 1 if ($_ =~ /^brackets.*\.txt/);
	}

	return %fnames;
}

sub join_path {
	my ($dname, $fname) = @_;

	$dname =~ tr/\\/\//;
	$dname =~ s/\/$//;
	return "$dname/$fname";
}

sub diff2 {
	my ($path1, $path2) = @_;

	open(BRA, $path1) || die "Failed to open: $path1\n";
	my @bra1 = <BRA>;
	close(BRA);

	open(BRA, $path2) || die "Failed to open: $path2\n";
	my @bra2 = <BRA>;
	close(BRA);

	return 1 if ($#bra1 != $#bra2);

	for (my $i = 0; $i <= $#bra1; $i++) {
		$bra1[$i] =~ s/\s*$//;
		$bra2[$i] =~ s/^.*g //;
		$bra2[$i] =~ s/\s*$//;
	}

	sort(@bra1);
	sort(@bra2);

	for (my $i = 0; $i <= $#bra1; $i++) {
		my $item1 = $bra1[$i];
		my $item2 = $bra2[$i];
		$item1 =~ s/\s*$//;
		$item2 =~ s/\s*$//;
		if ($item1 != $item2) {
			return 1;
		}
	}

	return 0;
}

sub main {
	my $dname = "./yours";
	my %fnames = &load_fnames($dname);

	foreach my $fname (keys(%fnames)) {
		my $path1 = &join_path($dname, $fname);
		my $path2;
		if ($fname =~ /2582/) {
			$path2 = "./characters2582.txt";
		} else {
			$path2 = "./characters288.txt";
		}

		if (&diff2($path1, $path2)) {
			printf STDERR ("differ \"%s\" and \"%s\"\n", $path1, $path2);
			$status = 1;
		}
	}

	return $status;
}

&main;
